#!/bin/bash

function show_help() {
	echo ''
	echo '参数错误！'
	echo '使用命令：./tfauth.sh  set|unset'
	echo 'set: 设置为支持双因子认证'
	echo 'unset: 取消双因子认证'
	echo ''
}

function set_tfauth() {
	file_name=$1
	echo '处理文件：'$file_name

	auth_line_n=$(grep -n "pam_nfs_auth.so" $file_name  | grep "auth_err=1")
	#echo $auth_line_n

	if [ -z "$auth_line_n" ]; then
		auth_line_n=$(grep -n "pam_nfs_auth.so" $file_name)
		#echo $auth_line_n

		if  [ -n "$auth_line_n" ] ; then
			n=$(echo $auth_line_n|awk '{split($1, arr,":");print arr[1]}')
			#echo $n
			sed -i "$[n]c auth	[auth_err=1 abort=die default=ignore]	pam_nfs_auth.so" $file_name 
		else
			auth_line_n=$(grep -n "pam_unix.so" $file_name)
			#echo $auth_line_n

			if  [ -n "$auth_line_n" ] ; then
				n=$(echo $auth_line_n|awk '{split($1, arr,":");print arr[1]}')
				#echo $n
				sed -i "$n iauth	[auth_err=1 abort=die default=ignore]	pam_nfs_auth.so" $file_name 
			fi
		fi
	else
		n=$(echo $auth_line_n|awk '{split($1, arr,":");print arr[1]}')
		#echo $n
		sed -i "${n}d" $file_name

		auth_line_n=$(grep -n "pam_nfs_auth.so" $file_name)
		#echo $auth_line_n

		if  [ -n "$auth_line_n" ] ; then
			n=$(echo $auth_line_n|awk '{split($1, arr,":");print arr[1]}')
			#echo $n
			sed -i "$[n]c auth	[auth_err=1 abort=die default=ignore]	pam_nfs_auth.so" $file_name 
		else
			auth_line_n=$(grep -n "pam_unix.so" $file_name)
			#echo $auth_line_n

			if  [ -n "$auth_line_n" ] ; then
				n=$(echo $auth_line_n|awk '{split($1, arr,":");print arr[1]}')
				#echo $n
				sed -i "$n iauth	[auth_err=1 abort=die default=ignore]	pam_nfs_auth.so" $file_name 
			fi
		fi
	fi
}

function get_number() {
	auth_line=$(grep "pam_unix.so" $file_name)
	#echo $auth_line

	if  [ -n "$auth_line" ] ; then
		n_str=$(echo $auth_line|grep -o '\[.*\]')
		#echo $n_str
		n_str=$(echo $n_str|awk '{split($1, arr," ");print arr[1]}')
		#echo $n_str
		n=$(echo $n_str|awk '{split($1, arr,"=");print arr[2]}')
		#echo $n
		n=`expr ${n} + 1`
		return $n
	fi
	return 0
}

function unset_tfauth() {
	file_name=$1
	echo '处理文件：'$file_name

	auth_line_n=$(grep -n "pam_nfs_auth.so" $file_name  | grep "auth_err=1")
	#echo $auth_line_n

	if  [ -n "$auth_line_n" ] ; then
		n=$(echo $auth_line_n|awk '{split($1, arr,":");print arr[1]}')
		#echo $n
		sed -i "${n}d" $file_name
	fi

	get_number
	sn=$?
	#echo $sn

	auth_line_n=$(grep -n "pam_nfs_auth.so" $file_name)
	#echo $auth_line_n

	if  [ -n "$auth_line_n" ] ; then
		n=$(echo $auth_line_n|awk '{split($1, arr,":");print arr[1]}')
		#echo $n
		sed -i "$[n]c auth	[success=${sn} abort=die default=ignore]	pam_nfs_auth.so" $file_name 
	else
		auth_line_n=$(grep -n "pam_unix.so" $file_name)
		#echo $auth_line_n

		if  [ -n "$auth_line_n" ] ; then
			n=$(echo $auth_line_n|awk '{split($1, arr,":");print arr[1]}')
			#echo $n
			sed -i "$n iauth	[success=${sn} abort=die default=ignore]	pam_nfs_auth.so" $file_name 
		fi
	fi
}

if [ $#  -ne 1 ]; then 
	show_help
	exit 1
fi

if [ "${1}" = 'set' ]; then
	set_tfauth '/etc/pam.d/lightdm'
	set_tfauth '/etc/pam.d/common-auth'
	echo '配置完成！'
elif [ "${1}" = 'unset' ]; then
	unset_tfauth '/etc/pam.d/lightdm'
	unset_tfauth '/etc/pam.d/common-auth'
	echo '配置完成！'
else
	show_help
	exit 1
fi
